/* ipqmpd - ip queuing multiplex daemon
 *
 *  (C) 2000 by Harald Welte <laforge@sunbeam.franken.de>
 *
 *  This code is released under the terms of GNU GPL
 *
 *  $Id: ctl.h,v 1.1 2000/08/19 17:17:57 laforge Exp $
 */

#ifndef _CTL_H
#define _CTL_H

#include "ipqmpd.h"

typedef struct ipqmpd_ctl_msg {
	char magic[4];
	u_int16_t type;
	u_int16_t len;
	unsigned char payload[0];
} ipqmpd_ctl_msg_t;

struct ipqmpd_ctl_msg_register {
	u_int32_t	flags;
	unsigned long 	mark;
	char		addr[PEER_ADDR_LEN];
};

struct ipqmpd_ctl_msg_setmode {
	u_int8_t	mode;
	size_t		range;
};


/* handles input from one of the established control sockets to a peer */
void ctl_inp(ipqmpd_peer_t *peer);

/* dequeues a packet from peer->out_q and sends it to peer->ctl_fd */
void ctl_outp(ipqmpd_peer_t *peer);

#endif /* _CTL_H */
